/* export.c -- export builtin */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include "util/symbol.h"
#include "util/llist.h"
#include "shell/redir.h"
#include "shell/shell.h"

/*****************************************************************************
 * Shell built-in export
 *
 * Arguments: export <var> <val>
 *****************************************************************************/
int _builtin_export(LinkedList *args)
{
  Symbol *s;
  if(numEntriesll(args) != 2) {
    outputerr("Invalid usage.  export takes 2 arguments\n");
    return 0;
  }
  s = AssignVar(args->s,args->next->s);
  if(s) return RET_SUCCESS;
  return RET_ERROR;
}
