/* jobs.c -- jobs builtin */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include "shell/process.h"
#include "shell/shell.h"

int _builtin_jobs(LinkedList *args)
{
  Job *job,*nextjob;
  int changed = 0;

  if(args != NULL) {
    if(!strcmp(args->s,"-n")) { // FIXME: Need to do this right
      changed = 1;
    }
  }
 
  job = getNextJob(NULL); 
  while(job) {
    nextjob = getNextJob(job);
    if(!changed || isJobChanged(job)) {
      clearJobChanged(job);
      if(!getASTQuiet(getJobAST(job)))
        outputout("[%d] %s           \"%s\"\n", getJobNum(job),
                  getJobStatusDesc(job), getJobCmdline(job));
      switch(getJobStatus(job)) {
        case JOB_DONE:
        case JOB_TERMINATED:
          RemoveJob(job);
          break;
        case JOB_RUNNING:
        case JOB_STOPPED:
        case JOB_SUSPENDED:
        default:
          break;
      }
    }
    job = nextjob;
  }
  return RET_SUCCESS;
}

