/* vars.c -- builtin vars */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include <stdlib.h>
#include "util/debug.h"
#include "util/symbol.h"
#include "shell/redir.h"
#include "shell/shell.h"

/*****************************************************************************
 * Shell built-in vars 
 *
 * Arguments: none 
 *****************************************************************************/
int _builtin_vars(LinkedList *list)
{
  Symbol *sp;

  for (sp = getNextSymbol(NULL); sp; sp = getNextSymbol(sp))
    if (isVar(sp)) outputout("  %s=%s\n", 
                             getSymbolName(sp), getSymbolValue(sp));
  return RET_SUCCESS;
}
