/* which.c -- Shell built-in which. */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include <string.h>
#include "shell/shell.h"
#include "shell/alias.h"
#include "util/debug.h"

int _builtin_which(LinkedList *args)
{
  char *s;
  char *cmd;
  
  if(numEntriesll(args) != 1) {
    outputerr("which: Incorrect number of arguments.  which programname\n");
    return RET_ERROR;
  }
  
  cmd = args->s;

  if(LookupBuiltin(cmd)) {
    outputout("which: %s is a shell built-in\n", cmd);
    return RET_SUCCESS;
  }
  if((s = ResolveAlias(cmd)) != NULL) {
    cmd = strdup(s);
    outputout("alias %s='%s'\n", args->s, cmd);
    s = strchr(cmd,' ');
    if(s != NULL) *s = 0;
    if(strcmp(cmd,args->s)) return _builtin_which(createll(cmd));
  }
  // make an AST to execute which
  outputout("which %s\n", cmd);
  return RET_SUCCESS;
}
