/* ast.h -- Abstract Syntax Tree for parser */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#ifndef _AST_H
#define _AST_H

#include "util/llist.h"
#include "shell/redir.h"

typedef struct ASTCommand {
  int type;
  char *var;
  char *expr;
  char *cmd;
  int bg;   // 0 - Don't start in background, 1 - Do start in background
  int quiet; // 0 - Don't print to stdout when status changes
  LinkedList *args;
  REDIR *redir;
  struct ASTCommand *next; // If output is piped to input of next cmd
} ASTCommand;

int getASTQuiet(ASTCommand *ast);
void freeAST(ASTCommand *ast);
ASTCommand *copyAST(ASTCommand *ast);
ASTCommand *newAST(void);

#define AST_ASGN 1
#define AST_FUNC 2
#define AST_HIST 3

#endif // #ifndef _AST_H
