/* charpp.c -- Functions for dealing with char ** data type. */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include <stdlib.h>
#include "util/debug.h"

void printpp(char **array)
{
  char **p = array;

  while(*p != NULL) {
     doutput("  %s\n", *p);
     p++;
  }
}

int lenpp(char **array)
{
  char **p = array;
  int n = 0;
  
  while(*p != NULL) {
     n++;
     p++;
  }
  return n;
}

char **copypp(char **src)
{
  char **array;
  int i = 0;
  char **p = src;

  array = emalloc(sizeof(char *) * lenpp(src)+1);
  while(*p != NULL) {
    array[i] = (char *) mystrdup(*p);
    i++;
    p++;
  }
  array[i] = NULL;
  return array;
}

void freepp(char **pp)
{
  char **p = pp;
  while(*p != NULL) {
    free(*p);
    p++;
  }
  free(p);
}
