#ifndef _SYMBOL_H

#define _SYMBOL_H 1

#include "util/llist.h"

#define _VAR 0
#define _BLTIN 1

typedef struct Symbol {
  char *name;
  short type;
  char *val;
  int (*ptr)();
  struct Symbol *next;
} Symbol;

Symbol *LookupBuiltin(char *str);
int VarExists(char *var);
char *VarValue(char *var);
Symbol *AssignVar(char *var, char *val);
Symbol *lookup(char *s);
Symbol *install(char *s, int t, char *v);
void RemoveAllVars(void);
int isBuiltin(Symbol *sym);
Symbol *getNextSymbol(Symbol *sym);
Symbol *newSymbol(void);

#endif
